# pylint: disable=W0611
from . import diagnostic
from .diagnostic import (
            acorr_ljungbox, acorr_breusch_godfrey,
            CompareCox, compare_cox, CompareJ, compare_j,
            HetGoldfeldQuandt, het_goldfeldquandt,
            het_breuschpagan, het_white, het_arch,
            linear_harvey_collier, linear_rainbow, linear_lm,
            breaks_cusumolsresid, breaks_hansen, recursive_olsresiduals,
            unitroot_adf,
            normal_ad, lilliefors,
             # deprecated because of misspelling:
            lillifors, het_breushpagan, acorr_breush_godfrey
            )

from . import multicomp
from .multitest import (multipletests, fdrcorrection, fdrcorrection_twostage,
                        local_fdr, NullDistribution)
from .multicomp import tukeyhsd
from . import gof
from .gof import (powerdiscrepancy, gof_chisquare_discrete,
                  chisquare_effectsize)
from . import stattools
from .stattools import durbin_watson, omni_normtest, jarque_bera

from . import sandwich_covariance
from .sandwich_covariance import (
            cov_cluster, cov_cluster_2groups, cov_nw_panel,
            cov_hac, cov_white_simple,
            cov_hc0, cov_hc1, cov_hc2, cov_hc3,
            se_cov
            )

from .weightstats import (DescrStatsW, CompareMeans, ttest_ind, ttost_ind,
                         ttost_paired, ztest, ztost, zconfint)

from .proportion import (binom_test_reject_interval, binom_test,
            binom_tost, binom_tost_reject_interval,
            power_binom_tost, power_ztost_prop,
            proportion_confint, proportion_effectsize,
            proportions_chisquare, proportions_chisquare_allpairs,
            proportions_chisquare_pairscontrol, proportions_ztest,
            proportions_ztost, multinomial_proportions_confint)

from .power import (TTestPower, TTestIndPower, GofChisquarePower,
                    NormalIndPower, FTestAnovaPower, FTestPower,
                    tt_solve_power, tt_ind_solve_power, zt_ind_solve_power)

from .descriptivestats import Describe

from .anova import anova_lm

from . import moment_helpers
from .correlation_tools import (corr_clipped, corr_nearest,
            corr_nearest_factor, corr_thresholded, cov_nearest,
            cov_nearest_factor_homog, FactoredPSDMatrix)

from statsmodels.sandbox.stats.runs import (Runs, runstest_1samp, runstest_2samp)

from statsmodels.stats.contingency_tables import (mcnemar, cochrans_q,
                                                  SquareTable,
                                                  Table2x2,
                                                  Table,
                                                  StratifiedTable)
from .mediation import Mediation
